#include <ESP8266WiFi.h>
#include <PubSubClient.h>

static const char SSID[] = "starbase";             // Raspberry Piɐݒ肵WiFi APSSID
static const char PASSWORD[] = "hogeFugapiyo";          // Raspberry Piɐݒ肵WiFi AP̃pX[h
static const char MQTT_SERVER[] = "(Broker IP)"; // MQTTu[J[̃AhX
static const uint16_t MQTT_PORT = 1883u;         // MQTTu[J[gpĂ|[gԍ
static const char MQTT_PUB_TOPIC[] = "topic";    // MQTT Publish topic
static const char MQTT_SUB_TOPIC[] = "topic";    // MQTT Subscribe topic

static WiFiClient wifiClient;           // WiFiڑsWiFiClient̃CX^X
static PubSubClient client(wifiClient); // MQTTu[J[ɐڑ邽߂PubSubClient̃CX^X

/**
 * WiFiڑ̃ZbgAbv
 */
static void setup_wifi() {
  Serial.println(F("Connecting to access point..."));
  WiFi.setSleepMode(WIFI_LIGHT_SLEEP);
  WiFi.begin(SSID, PASSWORD);                         // WiFI APɐڑ
  while(WiFi.status() != WL_CONNECTED) {              // ڑ܂ő҂
    delay(500);
  }
  randomSeed(micros());           // ̃V[hlNoߎԂ珉
}

/**
 * MQTT̃bZ[WMƂ̏snh
 */
static void on_mqtt_message_received(const char* topic, byte* payload, unsigned int length) {
    Serial.print(F("MQTT Pub Recv [")); // MQTT Pub Recv [topic] (payload) ̌`ŏo
    Serial.print(topic);
    Serial.print("]");
    while (length-- > 0) {
        Serial.print( static_cast<char>( *(payload++) ) );
    }
    Serial.println();
}

/**
 * PubSubClient̐ݒs
 */
static void setup_mqtt() {
  client.setServer(MQTT_SERVER, MQTT_PORT);     // u[J[̃AhXƃ|[gݒ
  client.setCallback(on_mqtt_message_received); // MbZ[W̃nhݒ
}

/**
 * MQTTu[J[ɐڑ
 */
static void mqtt_connect() {
  String clientId;
  while( !client.connected() ) {  // ڑ܂ŐڑsB
     Serial.print(F("Attempting MQTT connection..."));
     clientId = F("ESP8266");
     clientId += String(random(0xffff), HEX);	// ESP8266abcď`̃NCAgID𐶐

     if( client.connect(clientId.c_str()) ) { // ڑH
       Serial.println(F("MQTT connected"));   // 
       client.publish(MQTT_PUB_TOPIC, "hello world");
       client.subscribe(MQTT_SUB_TOPIC);
     }
     else {                                   // ڑs
       Serial.print(F("Connection failed, rc=")); // G[R[h\Ă
       Serial.print(client.state());
       Serial.println(F(" retry in 5 seconds."));
       delay(5000);
     }
  }
}

void setup() {
  pinMode(5, OUTPUT); // LEDpso̓[hɐݒ

  // ffpbZ[W\邽߂UARTB
  Serial.begin(115200); // 115,200[bps]
  delay(1000);
  Serial.println("Setting up...");

  // WiFiMQTTڑB
  setup_wifi();
  setup_mqtt();
}

static String message;                // MQTTbZ[W\zp
static long lastPublishTimestamp = 0; // ŌMQTTbZ[W𑗂^CX^v
static int value = 0;                 // MQTTbZ[W̔ԍ
void loop() {
  if( !client.connected() ) { // ܂MQTTu[J[ɐڑłĂȂꍇ͐ڑB
    mqtt_connect();
  }
  else {
    client.loop();            // ڑĂȂAڑێ邽߂̏B
  }

  long now = millis();        // ݂̃^CX^v[~b]擾
  if( now - lastPublishTimestamp > 2000 ) { // ŌɃbZ[WMĂ2bȏoH
    lastPublishTimestamp = now;
    
    message = F("Test Message #");  // bZ[WgݗĂ
    ++value;
    message.concat(value);
    
    Serial.print(F("Publish message: "));
    Serial.println(message);
    client.publish(MQTT_PUB_TOPIC, message.c_str());
  }
}